<template>
  <div>
    <div class="table-responsive">
      <table
        class="table table-head-custom table-vertical-center table-head-bg table-borderless mb-5"
      >
        <thead>
          <slot name="header"></slot>
        </thead>

        <tbody>
          <template v-if="loading">
            <tr>
              <td colspan="15">
                <div class="text-center">
                  <div class="spinner-border text-primary" role="status">
                    <span class="visually-hidden"></span>
                  </div>
                </div>
              </td>
            </tr>
          </template>

          <template v-if="!loading && !(data.length > 0)">
            <tr>
              <td colspan="15">
                <div class="text-center">
                  <i class="flaticon2-open-box text-secondary icon-3x"></i>

                  <h4>
                    Data kosong.
                  </h4>
                </div>
              </td>
            </tr>
          </template>

          <template v-if="!loading">
            <slot name="body"></slot>
          </template>

          <template v-if="!loading">
            <template v-for="(item, i) in paginatedData">
              <slot name="defaultBody" :item="item" :i="i"></slot>
            </template>
          </template>
        </tbody>
      </table>
    </div>

    <div class="d-flex justify-content-center mt-5">
      <b-pagination
        class="mt-5 mx-auto"
        v-model="currentPage"
        :total-rows="totalRows"
        :per-page="perPage"
        pills
        v-if="totalRows > 0"
      ></b-pagination>
    </div>
  </div>
</template>

<script>
export default {
  name: "CompleteTable",
  props: {
    data: {
      default: () => [],
      type: Array
    },
    loading: {
      default: true,
      type: Boolean
    },
    perPage: {
      default: 10,
      type: Number
    }
  },
  data() {
    return {
      currentPage: 1
    };
  },
  computed: {
    paginatedData() {
      const max = this.currentPage * this.perPage;

      const min = max - this.perPage;

      return this.data.filter((item, index) => {
        if (index + 1 <= max && index + 1 > min) {
          return item;
        }
      });
    },
    totalRows() {
      return this.data?.length;
    }
  }
};
</script>
